### 一.支持升级路径

|     源系统     |      目的系统      |  架构  |
| :------------: | :----------------: | :----: |
| OpenCloudOS8.6 | OpenCloudOS9.0/9.2 | X86_64 |
| OpenCloudOS8.8 | OpenCloudOS9.0/9.2 | X86_64 |

### 二.使用方式

```
leapp upgrade --opencloudos
```

可选项：

```
--target <version> #默认升级到9.2，使用此选项可指定版本
--reboot #自动执行重启命令，不用手动重启，如果系统满足条件则可以实现一条命令升级
--preupgrade #预升级检查，可以查看系统配置，软件包的配置和功能的变化，以及存在的风险
--enablerepo <reponame> #用户自建仓库进行升级
--nogpgcheck #升级过程中不检查签名
--debug #开发/测试人员使用，查看代码中设置的debug信息
--verbose #开启详细日志打印
```

### 三.说明

1.代码运行流程详见https://iwiki.woa.com/p/4008326704

2.迁移说明：

- 可在本地虚拟机，CVM（即deploy）和ndeploy（测试环境）上实现升级。

- 上述环境中，升级后，自动开启网络和ssh，不用手动连接。因此可实现远程升级，为后续多节点升级做好准备。
- 多内核升级时由于OC9中的grub和grubby的启动字段顺序对不上，默认不会进入最新内核，需用户手动进入最新内核。单内核不受影响。此处bug和迁移工具表现无关。
- 时长表现：经多次测试，在900-1000个软件包的系统中，重启前（即系统处于可用状态）耗时6-8分钟，具体时间和网络状况相关，因为新系统的软件包从软件源上获取，重启后耗时固定在4分30秒，整个过程在10-12分钟可完成。软件包数量增多时，时长会适当增加，即软件包数量越多，耗时越长，并不是线性增长。下面进行详细说明：
  - 整个迁移时长分为三部分：除软件包下载和依赖解析的代码运行时长，软件包下载和安装时长，软件包之间依赖关系解析时长
  - 除软件包下载和依赖解析的运行时长几乎固定，这是因为要检查的配置大多数为常见配置，多数系统都有，并且此部分耗时不长。
  - 软件包下载和安装时长和软件包数呈正相关，在一定程度上线性增长。较大的软件包在安装和下载时对时长影响较大。
  - 依赖解析时长和软件包数量相关，但是不是线性增长。这是因为依赖解析使用的libsolv，使用可满足性（SAT）理论来解决依赖关系，其时间复杂度大于等于O(n)，仅在理想情况下为O(n)。

3.测试方法：

- 在仅可以访问内网的机器上测试时，最好将`leapp-upgrade-repo-oc.repo`中的两个地址换一下，加快下载软件包时的解析速度
  - OC在外网用的比较多，因此迁移工具中的默认使用地址是外网的源，只能访问内网时，使用dnf在解析第一个外网的源失败时，才会访问第二个内网的源，所以耗时较长，在内网测试时，建议把地址对换一下，加快速度。
- 在使用vdo的机器上需要手动确认是否单独使用lvm而没有使用vdo，目前使用OC8.6/8.8的本地虚拟机，ndeploy和cvm上暂不受影响，因此直接在`/var/log/leapp/answerfile`上将conform的值设置为True即可，为了保险起见，暂保留这一判断。

### 四.TODO

1.VDO检查仍需用户手动确认，后续改为自动适配和迁移

2.桌面版本尚不支持

3.升级后测试系统各项服务启动状态的功能尚未实现

4.适配生产环境，尤其网关，pam等模块开启的情况下的表现尚不确定

5.接入兼容性检查工具，标准化检查流程