from leapp.actors import Actor
from leapp.libraries.actor.grubenvtofile import grubenv_to_file
from leapp.tags import DownloadPhaseTag, IPUWorkflowTag
import os
from leapp.libraries.stdlib import api, CalledProcessError, run

class GrubenvToFile(Actor):
    """
    Convert "grubenv" symlink to a regular file.
    
    #on Azure hybrid images using BIOS.
    """

    name = 'grubenvtofile'
    consumes = ()
    produces = ()
    tags = (DownloadPhaseTag, IPUWorkflowTag)

    def process(self):
        if os.path.exists("/sys/firmware/efi") and os.path.islink("/boot/grub2/grubenv"):
            grubenv_to_file()
