import os
from leapp.libraries.common.config import version
from leapp.libraries.common.rpms import has_package
from leapp.models import InstalledOpenCloudSignedRPM
from leapp.exceptions import StopActorExecutionError
from leapp.libraries.stdlib import CalledProcessError, run, api
from leapp.libraries.common.config import architecture


def fix_shim_for_oc9():
    target_version = version.get_target_version()
    if has_package(InstalledOpenCloudSignedRPM,'shim-aa64'):
        run(['dnf','remove','--noautoremove','shim-aa64','-y'])
        run(['dnf','--disablerepo=*',"--releasever={}".format(target_version),'--enablerepo=baseos-rpms,appstream-rpms','install','shim','-y'])
    else:
        run(['dnf','--disablerepo=*',"--releasever={}".format(target_version),'--enablerepo=baseos-rpms,appstream-rpms','install','shim','-y'])
    # if has_package(InstalledOpenCloudSignedRPM,'fwupdate-libs'):
        
def process():
    api.current_logger().info('in prepare_file')
    if os.path.exists("/sys/firmware/efi") and architecture.matches_architecture(architecture.ARCH_ARM64):
        fix_shim_for_oc9()