from leapp.actors import Actor
from leapp.models import PersistentNetNamesFacts
from leapp.tags import ChecksPhaseTag, IPUWorkflowTag
from leapp.libraries.stdlib import  run,api
from leapp.tags import FirstBootPhaseTag, IPUWorkflowTag

import pyudev,os
udev_context = pyudev.Context()

class EnableNetwork(Actor):
    """
    enalbe network
    """

    name = 'enable_network'
    consumes = (PersistentNetNamesFacts,)
    produces = ()
    tags = (FirstBootPhaseTag, IPUWorkflowTag)
    #tags = (ChecksPhaseTag, IPUWorkflowTag)  #unit test 

    def process(self):
        # Define a function to get the physical interfaces
        def physical_interfaces():
            # Create an enumerator object to match the net subsystem
            enumerator = pyudev.Enumerator(udev_context).match_subsystem('net')
            # Return a list of devices that do not start with /devices/virtual/
            return [d for d in enumerator if not d.device_path.startswith('/devices/virtual/')]
        # Iterate through the physical interfaces
        for dev in physical_interfaces():
            try:
                # Get the device name
                device_name = dev.sys_name
                # Run the nmcli command to connect the device
                run(['nmcli','device','connect',device_name])
            except Exception as e:
                # Log an error message if the device cannot be connected
                api.current_logger().info("Failed to enable network interface %s: %s" % (device_name, e))
        if os.environ['LEAPP_SET_DEFAULT'] == "graphical.target":
            run(["dnf","groupinstall", 'Server with GUI','-y'])
