from leapp.actors import Actor
from leapp.models import SystemdServicesTasks
from leapp.tags import ChecksPhaseTag, IPUWorkflowTag
from leapp.libraries.stdlib import  run
import os

class EnableDbusService(Actor):
    """
    Enables dbus.service systemd service.
    """

    name = 'enable_dbus_service'
    consumes = ()
    produces = (SystemdServicesTasks,)
    tags = (ChecksPhaseTag, IPUWorkflowTag)

    def process(self):
        SERVICE_NAME = "dbus-broker.service"
        NetworkManager_NAME="NetworkManager.service"
        SSHD_NAME="sshd.service"
        self.produce(SystemdServicesTasks(to_enable=[SERVICE_NAME]))
        self.produce(SystemdServicesTasks(to_enable=[NetworkManager_NAME]))
        self.produce(SystemdServicesTasks(to_enable=[SSHD_NAME]))
