from leapp.actors import Actor
from leapp.tags import ApplicationsPhaseTag, IPUWorkflowTag
import os
from leapp.libraries.stdlib import run
class OpenCloudOSRelease(Actor):
    """

    """
    name = 'opencloudos_release'
    consumes = ()
    produces = ()
    tags = (IPUWorkflowTag, ApplicationsPhaseTag)

    def process(self):
        # Remove the gpg-pubkey package
        run(['dnf','remove','gpg-pubkey','-y'])
        # If the file /etc/yum.repos.d/OpenCloudOS.repo.rpmnew exists
        if os.path.isfile('/etc/yum.repos.d/OpenCloudOS.repo.rpmnew'):
            try:
                # Move the file /etc/yum.repos.d/OpenCloudOS.repo to /etc/yum.repos.d/OpenCloudOS.repo.rpmnew.bak
                run(['mv','/etc/yum.repos.d/OpenCloudOS.repo','/etc/yum.repos.d/OpenCloudOS.repo.rpmnew.bak'])
                # Move the file /etc/yum.repos.d/OpenCloudOS.repo.rpmnew to /etc/yum.repos.d/OpenCloudOS.repo
                run(['mv','/etc/yum.repos.d/OpenCloudOS.repo.rpmnew','/etc/yum.repos.d/OpenCloudOS.repo'])
            except:
                pass
            # if os.path.isfile('/etc/yum.repos.d/OpenCloudOS-Debuginfo.repo'):
            #     # Remove the file /etc/yum.repos.d/OpenCloudOS-Debuginfo.repo
            #     run(['rm','-rf','/etc/yum.repos.d/OpenCloudOS-Debuginfo.repo'])
            # if os.path.isfile('/etc/yum.repos.d/OpenCloudOS-Sources.repo'):
            #     # Remove the file /etc/yum.repos.d/OpenCloudOS-Sources.repo
            #     run(['rm','-rf','/etc/yum.repos.d/OpenCloudOS-Sources.repo'])
        if os.environ['LEAPP_SET_DEFAULT'] == "multi-user.target":
            run(['systemctl','set-default','multi-user.target'])
        if os.environ['LEAPP_SET_DEFAULT'] == "graphical.target":
            # run(["dnf","groupinstall", 'Server with GUI','-y'])
            run(['systemctl','set-default','graphical.target'])